<template>
  <el-select
    v-model="selected"
    class="semester-select"
    :placeholder="placeholder"
    filterable
    :clearable="clearable"
    :disabled="disabled"
    style="width: 240px"
    @change="select"
  >
    <el-option
      v-for="item in optionList"
      :key="item.id"
      :value="item.id"
      :label="item.name"
    >
    </el-option>
  </el-select>
</template>

<script>
import { conditionListSemester } from "../../modules/base/api";

export default {
  name: "semester-select",
  props: {
    disabled: { type: Boolean, default: false },
    placeholder: { type: String, default: "请选择学期" },
    value: { type: [Number, String], default: "" },
    clearable: { type: Boolean, default: true },
    defaultSelect: { type: Boolean, default: false },
    enable: { type: Boolean, default: null },
  },
  data() {
    return {
      optionList: [],
      selected: "",
    };
  },
  watch: {
    value: {
      immediate: true,
      handler(val) {
        this.selected = val;
      },
    },
  },
  created() {
    this.search();
  },
  methods: {
    async search() {
      this.optionList = [];

      let data = {};
      if (this.enable !== null) data.enable = this.enable;
      const res = await conditionListSemester(data);
      this.optionList = res;

      if (this.defaultSelect && !this.value) this.selectDefault();
    },
    select() {
      this.$emit("input", this.selected);
      this.$emit(
        "change",
        this.optionList.find((item) => item.id === this.selected)
      );
    },
    selectDefault() {
      const defaultData = this.optionList[0];
      if (defaultData) {
        this.selected = defaultData.id;
        this.$emit("input", this.selected);
        this.$emit("change", defaultData);
        this.$emit("default-selected", defaultData);
      }
    },
  },
};
</script>
